import { MenuElement } from './menu_element.js';
import { HtmlClasses } from './html_classes.js';
export class AbstractEntry extends MenuElement {
    constructor(_menu, _type) {
        super();
        this._menu = _menu;
        this._type = _type;
        this.className = HtmlClasses['MENUITEM'];
        this.role = 'menuitem';
        this.hidden = false;
    }
    get menu() {
        return this._menu;
    }
    set menu(menu) {
        this._menu = menu;
    }
    get type() {
        return this._type;
    }
    hide() {
        this.hidden = true;
        this.menu.generateMenu();
    }
    show() {
        this.hidden = false;
        this.menu.generateMenu();
    }
    isHidden() {
        return this.hidden;
    }
}
//# sourceMappingURL=abstract_entry.js.map