export class VariablePool {
    constructor() {
        this.pool = {};
    }
    insert(variable) {
        this.pool[variable.name] = variable;
    }
    lookup(name) {
        return this.pool[name];
    }
    remove(name) {
        delete this.pool[name];
    }
    update() {
        for (const variable in this.pool) {
            this.pool[variable].update();
        }
    }
}
//# sourceMappingURL=variable_pool.js.map